{1- Se cuenta con un archivo directo llamado ALUMNOS.DAT con informacin de alumnos de una universidad. El archivo se abre para lectura y se indexa por medio de su clave primaria (#legajo). El ndice se mantiene en memoria principal. Se ofrece la posibilidad al usuario de buscar alumnos por legajo. La bsqueda binaria se aplica sobre el ndice y se accede en forma directa (seek) al archivo para recuperar el registro. Se asume que el archivo est ordenado de manera ascendente por su clave primaria (#legajo). Si ste no fuese el caso, el ndice debera ordenarse antes de aplicar una bsqueda binaria sobre l. Aclaracin: no se provee el archivo ALUMNOS.DAT (debido a que es binario). Deber ser generado antes de la ejecucin de este pro- grama).}
{Solucin en lenguaje Pascal}

PROGRAM cap08_ej01;

CONST TAMANIO_INDICE = 5;

TYPE t_fecha = RECORD
	dia, mes, anio: INTEGER;
	END;

	t_alumno = RECORD
	legajo: LONGINT;
	nomyap: STRING[30];
	documento: STRING[10];
	direccion: STRING[40];
	fecha_nac: t_fecha;
	END;

	{ Estructura de cada entrada en el ndice }
	t_entrada_indice = RECORD
	clave: LONGINT; { Clave de acceso (legajo) }
	posicion: LONGINT; { Posicin del registro en el archivo }
	END;

	t_indice = ARRAY[1..TAMANIO_INDICE] OF t_entrada_indice;
	t_arch_alumnos = FILE OF t_alumno;

PROCEDURE indexar(VAR arch: t_arch_alumnos; VAR indice: t_indice);
VAR 	alumno: t_alumno;
	posicion, i: INTEGER;

BEGIN
	i := 1;
	RESET(arch);

	WHILE (NOT EOF(arch)) DO
	BEGIN
		posicion := FILEPOS(arch);
		READ(arch, alumno);

		indice[i].clave := alumno.legajo;
		indice[i].posicion := posicion;
		INC(i);
	END;
END;

FUNCTION buscar(VAR arch: t_arch_alumnos; VAR indice: t_indice; legajo:
LONGINT; VAR alumno: t_alumno): BOOLEAN;

VAR 	inferior, superior, centro: LONGINT;
	encontrado: BOOLEAN;
BEGIN

	encontrado := FALSE;
	inferior := 1;
	superior := TAMANIO_INDICE;
	WHILE ( (inferior <= superior) AND (NOT encontrado) ) DO
		BEGIN
		centro := (inferior + superior) DIV 2; { Divisin entera }
		IF (indice[centro].clave = legajo) THEN
			BEGIN
				encontrado := TRUE;
			END
		ELSE
			BEGIN
				IF (legajo < indice[centro].clave) THEN
					superior := centro - 1 {Buscar en la primera mitad}
				ELSE
				inferior := centro + 1; { Buscar en la segunda mitad }
			END;
			END;
	IF (encontrado) THEN
	BEGIN
		SEEK(arch, indice[centro].posicion);
		READ(arch, alumno);
	END;

	buscar := encontrado;
END;
PROCEDURE mostrar_datos(alumno: t_alumno);

BEGIN
	WRITELN('Legajo: ', alumno.legajo);
	WRITELN('Nombre y apellido: ', alumno.nomyap);
	WRITELN('Documento de identidad: ', alumno.documento);
	WRITELN('Direccin: ', alumno.direccion);
	WRITELN('Fecha de nacimiento: ', alumno.fecha_nac.dia, '/',alumno.fecha_nac.mes, '/',alumno.fecha_nac.anio);
END;

VAR alumnos: 	t_arch_alumnos;
		indice: t_indice;
		legajo: LONGINT;
		alumno: t_alumno;
		encontrado: BOOLEAN;
		i: INTEGER;

{ Programa Principal }
BEGIN
	ASSIGN(alumnos, 'alumnos_pas.dat');
	RESET(alumnos);

	{ Indexacin del archivo }
	indexar(alumnos, indice);

	REPEAT
		WRITE('Ingrese un legajo a buscar (-1 para terminar): ');
		READLN(legajo);

		IF (legajo <> -1) THEN
		BEGIN
			{ Bsqueda binaria sobre el ndice }
			encontrado := buscar(alumnos, indice, legajo, alumno);
			IF (encontrado) THEN
				mostrar_datos(alumno)
			ELSE
				WRITELN('El legajo ', legajo, ' no se encuentra en el archivo.');
		END;
	WRITELN;

UNTIL (legajo = -1);
CLOSE(alumnos);
END.