/* 2- Se cuenta con el mismo archivo ALUMNOS.DAT del caso anterior. ste se abre para lectura y se indexa mediante su clave primaria (#legajo).El ndice se mantiene en memoria principal.Se ofrece la posibilidad al usuario de aadir o eliminar registros del archivo, lo que impacta en el tamao del ndice. Al final se muestra el contenido del ndice. No se asume orden particular alguno en el archivo. Por lo tanto, luego de la indexacin, el  ndice debe ordenarse.*/
/* Solucin en lenguaje C */

#include <stdio.h>
#include <string.h>
#include <limits.h>

#define MAX_TAMANIO_INDICE 100
typedef struct {
	int dia, mes, anio;
} t_fecha;

typedef struct {
	long legajo;
	char nomyap[30+1];
	char documento[10+1];
	char direccion[40+1];
	t_fecha fecha_nac;
} t_alumno;

/* Estructura de cada entrada en el ndice */
typedef struct {
	long clave; /* Clave de acceso (legajo) */
	long posicion; /* Posicin del registro en el archivo */
} t_entrada_indice;

typedef t_entrada_indice t_indice[MAX_TAMANIO_INDICE];

typedef enum {FALSO, VERDADERO} t_bool;

void indexar(FILE* arch, t_indice indice, long* tamanio_indice);
void cargar_alumno(FILE* arch, t_indice indice, long* tamanio_indice);
void eliminar_alumno(FILE* arch, t_indice indice, long* tamanio_indice);
void mostrar_indice(t_indice indice, long tamanio_indice);
void ordenar_indice(t_indice indice, long tamanio_indice);
long buscar(long legajo, t_indice indice, long tamanio_indice);
int main()
{
	FILE* alumnos;
	t_indice indice;
	long tamanio_indice;
	int opcion;

	if ((alumnos=fopen("alumnos.dat","r+b")) == NULL)
	{
		printf("No se puede abrir el archivo.\n");
		return 1;
	}

	/* Indexacin del archivo */
	indexar(alumnos, indice, &tamanio_indice);

	do
	{
	printf("1 -> Cargar nuevo alumno\n");
	printf("2 -> Eliminar alumno existente\n");
	printf("3 -> Salir\n");
	scanf("%d", &opcion);
	switch (opcion)
		{
		case 1: cargar_alumno(alumnos, indice, &tamanio_indice);
		break;
		case 2: eliminar_alumno(alumnos, indice, &tamanio_indice);
		break;
		}
	} while (opcion != 3);

	mostrar_indice(indice, tamanio_indice);

	fclose(alumnos);

	return 0;
}

void indexar(FILE* arch, t_indice indice, long* tamanio_indice)
{
	t_alumno alumno;
	int posicion, i = 0;
	rewind(arch);
	do
	{
		posicion = ftell(arch); /* Posicin actual del puntero a registro */
		fread(&alumno, sizeof(t_alumno), 1, arch);

		if (!feof(arch))
		{
			indice[i].clave = alumno.legajo;
			indice[i].posicion = posicion;
			i++;
		}

	} while (!feof(arch));

	*tamanio_indice = i;

	/* Reordenar ndice */
	ordenar_indice(indice, *tamanio_indice);
}

void cargar_alumno(FILE* arch, t_indice indice, long* tamanio_indice)
{
	t_alumno alumno;
	long posicion;
	int i;

	printf("Legajo: ");
	scanf("%ld", &(alumno.legajo));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Nombre y apellido: ");
	fgets(alumno.nomyap, 31, stdin);
	if (alumno.nomyap[strlen(alumno.nomyap)-1] == '\n')
		alumno.nomyap[strlen(alumno.nomyap)-1] = '\0';
	else
		while (getchar() != '\n'); /* Limpieza buffer de teclado */
	printf("Nmero de documento: ");
	fgets(alumno.documento, 11, stdin);
	if (alumno.documento[strlen(alumno.documento)-1] == '\n')
		alumno.documento[strlen(alumno.documento)-1] = '\0';
	else
		while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Direccin: ");
	fgets(alumno.direccion, 41, stdin);
	if (alumno.direccion[strlen(alumno.direccion)-1] == '\n')
		alumno.direccion[strlen(alumno.direccion)-1] = '\0';
	else
		while (getchar() != '\n'); /* Limpieza buffer de teclado */
	printf("Fecha de nacimiento:\n");
	printf("\tDa: ");
	scanf("%d", &(alumno.fecha_nac.dia));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */
	printf("\tMes: ");
	scanf("%d", &(alumno.fecha_nac.mes));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */
	printf("\tAo: ");
	scanf("%d", &(alumno.fecha_nac.anio));
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	fseek(arch, 0, SEEK_END); /* Posicionamiento al final, para agregado */
	posicion = ftell(arch);
	fwrite(&alumno, sizeof(t_alumno), 1, arch);

	/* Nueva entrada en el ndice */
	i = *tamanio_indice;
	indice[i].clave = alumno.legajo;
	indice[i].posicion = posicion;
	*tamanio_indice = *tamanio_indice + 1;

	/* Reordenar ndice */
	ordenar_indice(indice, *tamanio_indice);
}

void eliminar_alumno(FILE* arch, t_indice indice, long* tamanio_indice)
{
	long legajo;
	int i;

	printf("Legajo a eliminar: ");
	scanf("%ld", &legajo);
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	i = buscar(legajo, indice, *tamanio_indice);
	if (i == -1)
	{
		printf("El legajo %ld no fue encontrado.\n", legajo);
	}
	else
	{
		/* Para borrar la entrada en el ndice, es suficiente con asignar */
		/* el mayor valor posible para la clave y decrementar el tamao del */
		/* ndice. De esta manera, cuando se reordene el ndice, ese */
		/* registro se mover al final y no se tendr en cuenta en futuros */
		/* accesos. */
		indice[i].clave = LONG_MAX;
		ordenar_indice(indice, *tamanio_indice);
		*tamanio_indice = *tamanio_indice - 1;
	}
}

void mostrar_indice(t_indice indice, long tamanio_indice)
{
	int i;
	for (i=0; i<tamanio_indice; i++)
	{
		printf("%ld -> %ld\n", indice[i].clave, indice[i].posicion);
	}
	printf("\n");
}

void ordenar_indice(t_indice indice, long tamanio_indice)
{
	int i, j;
	t_entrada_indice aux;

	for (i = tamanio_indice-1; i > 0; i--)
		for (j = 1; j <= i; j++)
			if (indice[j-1].clave > indice[j].clave)
			{
			/* Intercambio */
			aux = indice[j];
			indice[j] = indice[j-1];
			indice[j-1] = aux;
	}
}

long buscar(long legajo, t_indice indice, long tamanio_indice)
{
	long inferior, superior, centro;
	inferior = 0;
	superior = tamanio_indice-1;

	while ( inferior <= superior )
	{
		centro = (inferior + superior) / 2; /* Divisin entera */

		if (indice[centro].clave == legajo)
			return centro;
		else
			if (legajo < indice[centro].clave)
			superior = centro - 1; /* Buscar en la primera mitad */
		else
			inferior = centro + 1; /* Buscar en la segunda mitad */
	}
	return -1;
}