{2- Se cuenta con el mismo archivo ALUMNOS.DAT del caso anterior. ste se abre para lectura y se indexa mediante su clave primaria (#legajo). El ndice se mantiene en memoria principal. Se ofrece la posibilidad al usuario de aadir o eliminar registros del archivo, lo que impacta en el tamao del ndice. Al final se muestra el contenido del ndice. No se asume orden particular alguno en el archivo. Por lo tanto, luego de la indexacin, el ndice debe ordenarse }
{Solucin en lenguaje Pascal}

PROGRAM cap08_ej02;

CONST 	MAX_TAMANIO_INDICE = 100;
	LONG_MAX = 2147483647;

TYPE t_fecha = RECORD
	dia, mes, anio: INTEGER;
	END;

	t_alumno = RECORD
	legajo: LONGINT;
	nomyap: STRING[30];
	documento: STRING[10];
	direccion: STRING[40];
	fecha_nac: t_fecha;
	END;

	{ Estructura de cada entrada en el ndice }
	t_entrada_indice = RECORD
	clave: LONGINT; { Clave de acceso (legajo) }
	posicion: LONGINT; { Posicin del registro en el archivo }
	END;

	t_indice = ARRAY[1..MAX_TAMANIO_INDICE] OF t_entrada_indice;
	t_arch_alumnos = FILE OF t_alumno;

PROCEDURE ordenar_indice(VAR indice: t_indice; tamanio_indice: LONGINT);

VAR 	i,j: LONGINT;
	aux: t_entrada_indice;
BEGIN
	FOR i:=tamanio_indice DOWNTO 2 DO
	FOR j:=2 TO i DO
		IF (indice[j-1].clave > indice[j].clave) THEN
		BEGIN
		{ Intercambio }
		aux := indice[j];
		indice[j] := indice[j-1];
		indice[j-1] := aux;
		END
END;

FUNCTION buscar(legajo: LONGINT; indice: t_indice; tamanio_indice: LONGINT):
LONGINT;

VAR inferior, superior, centro: LONGINT;
	encontrado: BOOLEAN;
BEGIN

	encontrado := FALSE;
	inferior := 1;
	superior := tamanio_indice;

	WHILE ( (inferior <= superior) AND (NOT encontrado) ) DO
	BEGIN
		centro := (inferior + superior) DIV 2; { Divisin entera }
		IF (indice[centro].clave = legajo) THEN
		BEGIN
			encontrado := TRUE;
		END
		ELSE
		BEGIN
			IF (legajo < indice[centro].clave) THEN
			superior := centro - 1 { Buscar en la primera mitad }
			ELSE
			inferior := centro + 1; { Buscar en la segunda mitad }
		END;
	END;

	IF (encontrado) THEN
	buscar := centro
	ELSE
	{ Si no lo encuentra, retorna -1 }
	buscar := -1;
END;

PROCEDURE indexar(VAR arch: t_arch_alumnos; VAR indice: t_indice; VAR
tamanio_indice: LONGINT);

VAR 	alumno: t_alumno;
	posicion, i: LONGINT;

BEGIN
	i := 1;
	RESET(arch);

	WHILE (NOT EOF(arch)) DO
	BEGIN
		posicion := FILEPOS(arch);
		READ(arch, alumno);

		indice[i].clave := alumno.legajo;
		indice[i].posicion := posicion;
		INC(i);
	END;

	tamanio_indice := i-1;

	{ Reordenar ndice }
	ordenar_indice(indice, tamanio_indice);
END;

PROCEDURE cargar_alumno(VAR arch: t_arch_alumnos; VAR indice: t_indice; VAR
tamanio_indice: LONGINT);

VAR 	alumno: t_alumno;
	posicion: LONGINT;

BEGIN
	WRITE('Legajo: ');
	READLN(alumno.legajo);
	WRITE('Nombre y apellido: ');
	READLN(alumno.nomyap);
	WRITE('Documento de identidad: ');
	READLN(alumno.documento);
	WRITE('Direccin: ');
	READLN(alumno.direccion);
	WRITE('Fecha Nacimiento (DD MM AAAA): ');
	READLN(alumno.fecha_nac.dia, alumno.fecha_nac.mes, alumno.fecha_nac.anio);

	SEEK(arch, FILESIZE(arch)); { Posicionamiento al final, para agregado }
	posicion := FILEPOS(arch);
	WRITE(arch, alumno);

	{ Nueva entrada en el ndice }
	INC(tamanio_indice);
	indice[tamanio_indice].clave := alumno.legajo;
	indice[tamanio_indice].posicion := posicion;

	{ Reordenar ndice }
	ordenar_indice(indice, tamanio_indice);
END;

PROCEDURE eliminar_alumno(VAR arch: t_arch_alumnos; VAR indice: t_indice; VAR
tamanio_indice: LONGINT);

VAR legajo,i: LONGINT;

BEGIN
	WRITE('Legajo a eliminar: ');
	READLN(legajo);

	i := buscar(legajo, indice, tamanio_indice);
	IF (i = -1) THEN
	BEGIN
		WRITELN('El legajo ', legajo, ' no fue encontrado.');
	END
	ELSE
	BEGIN
		{ Para borrar la entrada en el ndice, es suficiente con asignar }
		{ el mayor valor posible para la clave y decrementar el tamao del }
		{ ndice. De esta manera, cuando se reordene el ndice, ese }
		{ registro se mover al final y no se tendr en cuenta en futuros }
		{ accesos al ndice. }
		indice[i].clave := LONG_MAX;
		ordenar_indice(indice, tamanio_indice);
		DEC(tamanio_indice);
	END;
END;

PROCEDURE mostrar_indice(indice: t_indice; tamanio_indice: LONGINT);

VAR i: LONGINT;

BEGIN
	FOR i:=1 TO tamanio_indice DO
	WRITELN(indice[i].clave, ' -> ', indice[i].posicion);
	WRITELN;
END;

VAR 	alumnos: t_arch_alumnos;
	indice: t_indice;
	tamanio_indice: LONGINT;
	opcion: INTEGER;

{ Programa Principal }
BEGIN

	ASSIGN(alumnos, 'alumnos_pas.dat');
	RESET(alumnos);

	{ Indexacin del archivo }
	indexar(alumnos, indice, tamanio_indice);
	REPEAT
		WRITELN('1 -> Cargar nuevo alumno');
		WRITELN('2 -> Eliminar alumno existente');
		WRITELN('3 -> Salir');
		READLN(opcion);

		CASE (opcion) OF
		1: cargar_alumno(alumnos, indice, tamanio_indice);
		2: eliminar_alumno(alumnos, indice, tamanio_indice);
		END;
		UNTIL (opcion = 3);

mostrar_indice(indice, tamanio_indice);

CLOSE(alumnos);

END.