/* 3- Con el mismo archivo ALUMNOS.DAT del primer problema del captulo. cree un algortimo que abra el archivo para lectura y se lo indexe por medio de #legajo y de #documento de identidad. Ambos ndices deben mantenerse en la memoria principal. Por ltimo, liste el contenido del archivo completo, ordenado por #legajo (haciendo uso del ndice por #legajo) y ordene por #documento de identidad (haciendo uso del ndice por #documento de identidad). En este ejemplo se ilustra de qu manera se puede manipular un archivo como si estuviese ordenado por diferentes campos sin necesidad de reordenarlo.*/
/* Solucin en lenguaje C */

#include <stdio.h>
#include <string.h>

#define MAX_TAMANIO_INDICE 50

typedef struct {
	int dia, mes, anio;
} t_fecha;

typedef struct {
	long legajo;
	char nomyap[30+1];
	char documento[10+1];
	char direccion[40+1];
	t_fecha fecha_nac;
} t_alumno;

/* ndice por #legajo */
typedef struct {
	long clave; /* Clave de acceso (legajo) */
	long posicion; /* Posicin del registro en el archivo */
} t_entrada_indice_legajo;
typedef t_entrada_indice_legajo t_indice_legajo[MAX_TAMANIO_INDICE];

/* ndice por #documento */
typedef struct {
	char clave[10+1]; /* Clave de acceso (documento de identidad) */
	long posicion; /* Posicin del registro en el archivo */
} t_entrada_indice_documento;
typedef t_entrada_indice_documento t_indice_documento[MAX_TAMANIO_INDICE];

typedef enum {FALSO, VERDADERO} t_bool;

void indexar(FILE* arch, t_indice_legajo ind_leg, t_indice_documento ind_doc,
long* tamanio_indice);
void listar_por_legajo(FILE* arch, t_indice_legajo indice, long
tamanio_indice);
void listar_por_documento(FILE* arch, t_indice_documento indice, long
tamanio_indice);
void ordenar_indice_legajo(t_indice_legajo indice, long tamanio_indice);
void ordenar_indice_documento(t_indice_documento indice, long tamanio_indice);
void mostrar_datos(t_alumno alumno);

int main()
{
	FILE* alumnos;
	t_indice_legajo indice_legajo;
	t_indice_documento indice_documento;
	long tamanio_indice;
	if ((alumnos=fopen("alumnos.dat","rb")) == NULL)
	{
		printf("No se puede abrir el archivo.\n");
		return 1;
	}

	/* Indexacin por #legajo y #documento */
	indexar(alumnos, indice_legajo, indice_documento, &tamanio_indice);

	/* Listado del archivo ordenado por #legajo */
	listar_por_legajo(alumnos, indice_legajo, tamanio_indice);

	/* Listado del archivo ordenado por #documento */
	listar_por_documento(alumnos, indice_documento, tamanio_indice);

	fclose(alumnos);
	return 0;
}

void indexar(FILE* arch, t_indice_legajo ind_leg, t_indice_documento ind_doc,
long* tamanio_indice)
{
	t_alumno alumno;
	int posicion, i = 0;
	rewind(arch);
	do
	{
		posicion = ftell(arch); /* Posicin actual del puntero a registro */
		fread(&alumno, sizeof(t_alumno), 1, arch);

		if (!feof(arch))
		{
		/* Nueva entrada en el ndice por legajo */
		ind_leg[i].clave = alumno.legajo;
		ind_leg[i].posicion = posicion;

		/* Nueva entrada en el ndice por documento de identidad */
		strcpy(ind_doc[i].clave, alumno.documento);
		ind_doc[i].posicion = posicion;

		i++;
	}

	} while (!feof(arch));
	*tamanio_indice = i;

	/* Reordenar ndices */
	ordenar_indice_legajo(ind_leg, *tamanio_indice);
	ordenar_indice_documento(ind_doc, *tamanio_indice);
}

void listar_por_legajo(FILE* arch, t_indice_legajo indice, long
tamanio_indice)
{
	t_alumno alumno;
	int i;

	printf("LISTADO ORDENADO POR #LEGAJO\n\n");
	for (i=0; i<tamanio_indice; i++)
	{
	fseek(arch, indice[i].posicion, SEEK_SET);
	fread(&alumno, sizeof(t_alumno), 1, arch);
	mostrar_datos(alumno);
	printf("\n");
	}
}

void listar_por_documento(FILE* arch, t_indice_documento indice, long
tamanio_indice)
{
	t_alumno alumno;
	int i;

	printf("LISTADO ORDENADO POR #DOCUMENTO DE IDENTIDAD\n\n");
	for (i=0; i<tamanio_indice; i++)
	{
		fseek(arch, indice[i].posicion, SEEK_SET);
		fread(&alumno, sizeof(t_alumno), 1, arch);
		mostrar_datos(alumno);
		printf("\n");
	}
}

void ordenar_indice_legajo(t_indice_legajo indice, long tamanio_indice)
{
	int i, j;
	t_entrada_indice_legajo aux;

	for (i = tamanio_indice-1; i > 0; i--)
		for (j = 1; j <= i; j++)
			if (indice[j-1].clave > indice[j].clave)
		{
		/* Intercambio */
		aux = indice[j];
		indice[j] = indice[j-1];
		indice[j-1] = aux;
		}
}

void ordenar_indice_documento(t_indice_documento indice, long tamanio_indice)
{
	int i, j;
	t_entrada_indice_documento aux;

	for (i = tamanio_indice-1; i > 0; i--)
		for (j = 1; j <= i; j++)
			if (strcmp(indice[j-1].clave, indice[j].clave) > 0)
			{
			/* Intercambio */
			aux = indice[j];
			indice[j] = indice[j-1];
			indice[j-1] = aux;
			}
}
void mostrar_datos(t_alumno alumno)
{
	printf("Legajo: %ld\n", alumno.legajo);
	printf("Nombre y apellido: %s\n", alumno.nomyap);
	printf("Documento de identidad: %s\n", alumno.documento);
	printf("Direccin: %s\n", alumno.direccion);
	printf("Fecha de nacimiento: %d/%d/%d\n", alumno.fecha_nac.dia,alumno.fecha_nac.mes, alumno.fecha_nac.anio);
}
