{3- Con el mismo archivo ALUMNOS.DAT del primer problema del captulo. cree un algortimo que abra el archivo para lectura y se lo indexe por medio de #legajo y de #documento de identidad. Ambos ndices deben mantenerse en la memoria principal. Por ltimo, liste el contenido del archivo completo, ordenado por #legajo (haciendo uso del ndice por #legajo) y ordene por #documento de identidad (haciendo uso del ndice por #documento de identidad). En este ejemplo se ilustra de qu manera se puede manipular un archivo como si estuviese ordenado por diferentes campos sin necesidad de reordenarlo.}
{Solucin en lenguaje Pascal}

PROGRAM cap08_ej03;

CONST MAX_TAMANIO_INDICE = 50;

TYPE t_fecha = RECORD
	dia, mes, anio: INTEGER;
	END;

	t_alumno = RECORD
	legajo: LONGINT;
	nomyap: STRING[30];
	documento: STRING[10];
	direccion: STRING[40];
	fecha_nac: t_fecha;
	END;

	{ ndice por #legajo }
	t_entrada_indice_legajo = RECORD
	clave: LONGINT; { Clave de acceso (legajo) }
	posicion: LONGINT; { Posicin del registro en el archivo }
	END;
	t_indice_legajo = ARRAY[1..MAX_TAMANIO_INDICE] OF t_entrada_indice_legajo;

	{ ndice por #documento }
	t_entrada_indice_documento = RECORD
	clave: STRING[10]; { Clave de acceso (documento de identidad) }
	posicion: LONGINT; { Posicin del registro en el archivo }
	END;
	t_indice_documento = ARRAY[1..MAX_TAMANIO_INDICE] OF t_entrada_indice_documento;
	t_arch_alumnos = FILE OF t_alumno;
PROCEDURE ordenar_indice_legajo(VAR indice: t_indice_legajo; tamanio_indice: LONGINT);

VAR i,j: LONGINT;
	aux: t_entrada_indice_legajo;
BEGIN
	FOR i:=tamanio_indice DOWNTO 2 DO
	FOR j:=2 TO i DO
		IF (indice[j-1].clave > indice[j].clave) THEN
		BEGIN
		{ Intercambio }
		aux := indice[j];
		indice[j] := indice[j-1];
		indice[j-1] := aux;
		END
	END;

PROCEDURE ordenar_indice_documento(VAR indice: t_indice_documento; tamanio_indice: LONGINT);

VAR i,j: LONGINT;
	aux: t_entrada_indice_documento;

BEGIN
	FOR i:=tamanio_indice DOWNTO 2 DO
	FOR j:=2 TO i DO
		IF (indice[j-1].clave > indice[j].clave) THEN
		BEGIN
		{ Intercambio }
		aux := indice[j];
		indice[j] := indice[j-1];
		indice[j-1] := aux;
		END
END;

PROCEDURE mostrar_datos(alumno: t_alumno);

BEGIN
	WRITELN('Legajo: ', alumno.legajo);
	WRITELN('Nombre y apellido: ', alumno.nomyap);
	WRITELN('Documento de identidad: ', alumno.documento);
	WRITELN('Direccin: ', alumno.direccion);
	WRITELN('Fecha de nacimiento: ', alumno.fecha_nac.dia, '/', alumno.fecha_nac.mes, '/',alumno.fecha_nac.anio);
END;

PROCEDURE indexar(VAR arch: t_arch_alumnos; VAR ind_leg: t_indice_legajo; VAR
ind_doc: t_indice_documento; VAR tamanio_indice: LONGINT);

VAR 	alumno: t_alumno;
	posicion, i: LONGINT;
BEGIN
	i := 1;
	RESET(arch);
	WHILE (NOT EOF(arch)) DO
		BEGIN
			posicion := FILEPOS(arch);
			READ(arch, alumno);
			ind_leg[i].clave := alumno.legajo;
			ind_leg[i].posicion := posicion;
			ind_doc[i].clave := alumno.documento;
			ind_doc[i].posicion := posicion;
			INC(i);
		END;

	tamanio_indice := i-1;

	{ Reordenar ndices }
	ordenar_indice_legajo(ind_leg, tamanio_indice);
	ordenar_indice_documento(ind_doc, tamanio_indice);
	END;

	PROCEDURE listar_por_legajo(VAR arch: t_arch_alumnos; VAR indice: t_indice_legajo; VAR tamanio_indice: LONGINT);
	VAR alumno: t_alumno;
	i: LONGINT;

BEGIN
	WRITELN('LISTADO ORDENADO POR #LEGAJO');
	WRITELN;

	FOR i:=1 TO tamanio_indice DO
	BEGIN
		SEEK(arch, indice[i].posicion);
		READ(arch, alumno);
		mostrar_datos(alumno);
		WRITELN;
	END;
END;

PROCEDURE listar_por_documento(VAR arch: t_arch_alumnos; VAR indice: t_indice_documento; VAR tamanio_indice: LONGINT);

VAR 	alumno: t_alumno;
	i: LONGINT;

BEGIN
	WRITELN('LISTADO ORDENADO POR #DOCUMENTO DE IDENTIDAD');
	WRITELN;

	FOR i:=1 TO tamanio_indice DO
	BEGIN
		SEEK(arch, indice[i].posicion);
		READ(arch, alumno);
		mostrar_datos(alumno);
		WRITELN;
	END;
END;

VAR 	alumnos: t_arch_alumnos;
	indice_legajo: t_indice_legajo;
	indice_documento: t_indice_documento;
	tamanio_indice: LONGINT;

{ Programa Principal }
BEGIN
	ASSIGN(alumnos, 'alumnos_pas.dat');
	RESET(alumnos);

	{ Indexacin por #legajo y #documento }
	indexar(alumnos, indice_legajo, indice_documento, tamanio_indice);
	listar_por_legajo(alumnos, indice_legajo, tamanio_indice);
	{ Listado del archivo ordenado por #documento }
	listar_por_documento(alumnos, indice_documento, tamanio_indice);

	CLOSE(alumnos);
END.